
  <!DOCTYPE html>
  <html>
    <head>
      <title>useCustomizedTooltipWrapperProps.tsx</title>
      <link href="https://cdn.jsdelivr.net/npm/semantic-ui@2.4.2/dist/semantic.min.css" type="text/css" rel="stylesheet">
      <script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.2/codemirror.min.js" type="text/javascript" charset="utf-8"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.2/mode/javascript/javascript.min.js" type="text/javascript" charset="utf-8"></script>
<link href="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.2/codemirror.min.css" type="text/css" rel="stylesheet">
<script src="../../../../../assets/source-file.js" type="text/javascript" charset="utf-8"></script>
<link href="../../../../../assets/source-file.css" type="text/css" rel="stylesheet">
    </head>
    <body>
    <div style="margin-top:3em" class="ui container"><h1 class="ui header"><a href="../../../../../index.html">TypeScript coverage report</a></h1><table style="margin-top:2em" class="ui celled table"><thead class=""><tr class=""><th class="">Filename</th><th class="">Percent</th><th class="">Threshold</th><th class="">Total</th><th class="">Covered</th><th class="">Uncovered</th></tr></thead><tbody class=""><tr class="positive"><td class="">src/components/Graphic/hooks/useCustomizedTooltipWrapperProps.tsx</td><td class="">98.55%</td><td class="">80%</td><td class="">276</td><td class="">272</td><td class="">4</td></tr></tbody></table><textarea id="editor" readonly="" style="margin-top:3em">import React, { CSSProperties, useCallback, useMemo } from &#x27;react&#x27;;
import { CustomizedTooltip } from &#x27;../components/CustomizedTooltip&#x27;;
import { InternalSelectedPoint, SelectedPoint } from &#x27;../Graphic&#x27;;

export interface CustomizedTooltipWrapperProps&lt;Key extends string = string&gt; {
  selectedPoint?: null | InternalSelectedPoint&lt;Key&gt;;
  selectedBatches: Key[];
  onChangeSelectedBatches?: (value: Key[]) =&gt; void;
  excludedBatches: Key[];
  onChangeExcludedBatches?: (value: Key[]) =&gt; void;
  selectedPoints: SelectedPoint&lt;Key&gt;[];
  onChangeSelectedPoints?: (value: SelectedPoint&lt;Key&gt;[]) =&gt; void;
  excludedPoints: SelectedPoint&lt;Key&gt;[];
  onChangeExcludedPoints?: (value: SelectedPoint&lt;Key&gt;[]) =&gt; void;
  renderTooltip: (value: SelectedPoint&lt;Key&gt;) =&gt; React.ReactNode;
  showIncludeExcludeControls?: boolean;
  onUnselectPoint: () =&gt; void;
}

const useWrapperStyle = (): CSSProperties =&gt;
  useMemo(
    () =&gt; ({
      zIndex: 1000,
      pointerEvents: &#x27;all&#x27;
    }),
    []
  );
export const useCustomizedTooltipWrapperProps = &lt;Key extends string = string&gt;({
  selectedPoint,
  excludedBatches,
  excludedPoints,
  selectedBatches,
  selectedPoints,
  onChangeExcludedPoints,
  onChangeExcludedBatches,
  onChangeSelectedBatches,
  onChangeSelectedPoints,
  renderTooltip,
  onUnselectPoint,
  showIncludeExcludeControls
}: CustomizedTooltipWrapperProps&lt;Key&gt;) =&gt; {
  const isTooltipActive = Boolean(
    selectedPoint &amp;&amp; selectedPoint.cx &amp;&amp; selectedPoint.cy
  );
  const isBatchSelected = useMemo(
    () =&gt;
      Boolean(selectedPoint &amp;&amp; selectedBatches.includes(selectedPoint.dataKey)),
    [selectedBatches, selectedPoint]
  );
  const isPointSelected = useMemo(
    () =&gt;
      Boolean(
        selectedPoint &amp;&amp;
          selectedPoints?.find(
            (point) =&gt;
              point.x === selectedPoint.x &amp;&amp; point.y === selectedPoint.y
          )
      ),
    [selectedPoint, selectedPoints]
  );
  const isBatchExcluded = useMemo(
    () =&gt;
      Boolean(
        selectedPoint &amp;&amp; excludedBatches?.includes(selectedPoint.dataKey)
      ),
    [excludedBatches, selectedPoint]
  );
  const isPointExcluded = useMemo(
    () =&gt;
      Boolean(
        selectedPoint &amp;&amp;
          excludedPoints?.find(
            (point) =&gt;
              point.x === selectedPoint.x &amp;&amp; point.y === selectedPoint.y
          )
      ),
    [excludedPoints, selectedPoint]
  );
  const onBatchChange = useCallback(
    (wasSelected?: boolean, wasExcluded?: boolean) =&gt; {
      if (!selectedPoint) return;
      if (typeof wasExcluded === &#x27;boolean&#x27;) {
        if (!onChangeExcludedBatches) return;
        if (wasExcluded) {
          onChangeExcludedBatches(
            excludedBatches.filter(
              (excludedBatch) =&gt; excludedBatch !== selectedPoint.dataKey
            )
          );
        } else {
          onChangeExcludedBatches(
            excludedBatches.concat(selectedPoint.dataKey)
          );
        }
      } else {
        if (!onChangeSelectedBatches) return;
        if (wasSelected) {
          onChangeSelectedBatches(
            selectedBatches.filter(
              (selectedBatch) =&gt; selectedBatch !== selectedPoint.dataKey
            )
          );
        } else {
          onChangeSelectedBatches(
            selectedBatches.concat(selectedPoint.dataKey)
          );
        }
      }
    },
    [
      excludedBatches,
      onChangeExcludedBatches,
      onChangeSelectedBatches,
      selectedBatches,
      selectedPoint
    ]
  );
  const onPointChange = useCallback(
    (wasSelected?: boolean, wasExcluded?: boolean) =&gt; {
      if (!selectedPoint) return;
      if (typeof wasExcluded === &#x27;boolean&#x27;) {
        if (!onChangeExcludedPoints) return;
        if (wasExcluded) {
          onChangeExcludedPoints(
            excludedPoints.filter(
              (excludedPoint) =&gt;
                !(
                  excludedPoint.y === selectedPoint.y &amp;&amp;
                  excludedPoint.x === selectedPoint.x &amp;&amp;
                  excludedPoint.dataKey === selectedPoint.dataKey &amp;&amp;
                  excludedPoint.id === selectedPoint.id
                )
            )
          );
        } else {
          onChangeExcludedPoints(excludedPoints.concat(selectedPoint));
        }
      } else {
        if (!onChangeSelectedPoints) return;
        if (wasSelected) {
          onChangeSelectedPoints(
            selectedPoints.filter(
              (point) =&gt;
                !(
                  point.y === selectedPoint.y &amp;&amp;
                  point.x === selectedPoint.x &amp;&amp;
                  point.dataKey === selectedPoint.dataKey &amp;&amp;
                  point.id === selectedPoint.id
                )
            )
          );
        } else {
          onChangeSelectedPoints(selectedPoints.concat(selectedPoint));
        }
      }
    },
    [
      excludedPoints,
      onChangeExcludedPoints,
      onChangeSelectedPoints,
      selectedPoint,
      selectedPoints
    ]
  );

  const showExclusion = Boolean(
    onChangeExcludedBatches || onChangeExcludedPoints
  );
  return {
    cursor: false,
    active: isTooltipActive,
    position: isTooltipActive
      ? { x: selectedPoint!.cx, y: selectedPoint!.cy }
      : undefined,
    wrapperStyle: useWrapperStyle(),
    content: ({ active }: any) =&gt;
      active ? (
        &lt;CustomizedTooltip
          showExclusion={showExclusion}
          showIncludeExcludeControls={showIncludeExcludeControls}
          isBatchSelected={isBatchSelected}
          isPointSelected={isPointSelected}
          isBatchExcluded={isBatchExcluded}
          isPointExcluded={isPointExcluded}
          onClose={onUnselectPoint}
          onBatchChange={onBatchChange}
          onPointChange={onPointChange}
          content={selectedPoint ? renderTooltip(selectedPoint) : null}
          active={isTooltipActive}
        /&gt;
      ) : null
  };
};
</textarea><pre id="annotations" style="display:none">[{&quot;file&quot;:&quot;src/components/Graphic/hooks/useCustomizedTooltipWrapperProps.tsx&quot;,&quot;line&quot;:172,&quot;character&quot;:13,&quot;text&quot;:&quot;selectedPoint!&quot;,&quot;kind&quot;:5},{&quot;file&quot;:&quot;src/components/Graphic/hooks/useCustomizedTooltipWrapperProps.tsx&quot;,&quot;line&quot;:172,&quot;character&quot;:35,&quot;text&quot;:&quot;selectedPoint!&quot;,&quot;kind&quot;:5},{&quot;file&quot;:&quot;src/components/Graphic/hooks/useCustomizedTooltipWrapperProps.tsx&quot;,&quot;line&quot;:175,&quot;character&quot;:16,&quot;text&quot;:&quot;active&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/components/Graphic/hooks/useCustomizedTooltipWrapperProps.tsx&quot;,&quot;line&quot;:176,&quot;character&quot;:6,&quot;text&quot;:&quot;active&quot;,&quot;kind&quot;:1}]</pre></div>
    <p class="footer-text">TypeScript Coverage Report generated by <a href="https://github.com/plantain-00/type-coverage">type-coverage</a> and <a href="https://github.com/alexcanessa/typescript-coverage-report">typescript-coverage-report</a> at Tue, 05 Oct 2021 23:09:04 GMT</p>
    </body>
  </html>
  